##parameters=REQUEST=None, theme=None, **kw

tmtool = context.portal_themes
mcat = context.cpsskins_getlocalizer()

if REQUEST is not None:
    kw.update(REQUEST.form)

cacheable_templets = kw.get('cache', [])

if cacheable_templets:
     theme_container = tmtool.getEffectiveThemeContainer(theme=theme)
     pageblocks =  theme_container.getPageBlocks()
     for pageblock in pageblocks:
         objects = pageblock.getObjects() 
         templets = objects.get('templets', [])
         for templets_in_block in templets.values():
             for templet in templets_in_block:
                if templet.getId() in cacheable_templets:
                    templet.manage_changeProperties(cacheable=1)
                else:
                    templet.manage_changeProperties(cacheable=0)

if REQUEST is not None:
     url = REQUEST['HTTP_REFERER'] + '&portal_status_message=' + mcat('_Cache parameters updated_')
     REQUEST.RESPONSE.redirect(url)
