##parameters=theme=None, edit=None

REQUEST = context.REQUEST
if REQUEST is not None:
   REQUEST.RESPONSE.setHeader('Content-Type', 'text/css')
   if edit:
      REQUEST.RESPONSE.setHeader('Expires', 'Sat, 1 Jan 2000 00:00:00 GMT')
      REQUEST.RESPONSE.setHeader('Pragma', 'no-cache')
   else:
      REQUEST.response.setHeader('Cache-Control','public, max-age=3600')

tmtool = context.portal_themes
container = tmtool.getEffectiveThemeContainer(theme=theme)
ramcache = tmtool.getRAMCache()

styles_dir = getattr(container, 'styles', None)
if styles_dir is None:
    return

for obj in styles_dir.objectValues():
       meth = getattr(obj, 'isPortalStyle', None)
       if callable(meth) and meth():
          try:
              if edit or not ramcache:
                   print obj.render() 
              else:
                   print context.cpsskins_render(obj)
          except:
              pass

return printed
