##parameters=obj=None, context_obj=None

if obj is None or context_obj is None:
   return 

atool = context.portal_actions
tmtool = context.portal_themes
portal_url = context.portal_url(relative=0)

action_categories = getattr(obj, 'action_categories', None) 
custom_action_categories = getattr(obj, 'custom_action_categories', None) 
show_action_icons = getattr(obj, 'show_action_icons', None) 
invisible_actions = getattr(obj, 'invisible_actions', None) 

categories = action_categories
if custom_action_categories != ['']:
    categories = categories + custom_action_categories

actions = atool.listFilteredActionsFor(context_obj)

actioninfo = []

firstcat = 1
for category in categories:
    actions_by_cat = actions.get(category, [])

    if firstcat:
       newcat = 0
    elif one_action_is_visible:
       newcat = 1
    one_action_is_visible = 0
    for action in actions_by_cat:
       action_dict = {}
       action_id = action.get('id', None)
       action_url = action.get('url', None)

       if invisible_actions is None or action_id not in invisible_actions:
            one_action_is_visible = 1
            we_are_here = context.cpsskins_weAreHere(action_url)
            icon = tmtool.getIconFor(category, action_id)

            menustyle = ''
            if icon and show_action_icons:
                menustyle = 'background-image: url(%s/%s);' % (portal_url, icon) 

            menuclass = we_are_here and 'submenuin' or 'submenuout'

            action_dict['we_are_here'] = we_are_here
            action_dict['title'] = action.get('name', None)
            action_dict['url'] = action.get('url', None)
            action_dict['class'] = menuclass
            action_dict['style'] = menustyle
            action_dict['newcat'] = newcat
            actioninfo.append(action_dict)
            newcat = 0 
    firstcat = 0
return actioninfo
