##parameters=level=0, base=None, show_docs=None, base_path=None

# XXX backward compatibilty since the trailing '/' was omitted
# in previous versions, this will be moved to the 
# rebuild theme method.

l = len(base_path)
if base_path[l-1:l] != '/':
   base_path = base_path + '/'

# end backward compatibility code

delta = len(base_path.split('/')) -3
rel_level = level
if delta > 0:
   rel_level = level + delta


if show_docs is None:
   show_docs = 0
else:
   try:
      show_docs=int(show_docs)
   except:
      show_docs = 0


if base is None:
    return

ttool = context.portal_trees
utool = context.portal_url
mtool = context.portal_membership

if base not in context.cpsskins_listFolderRoots():
    return

if hasattr(ttool, base):
    base_obj = ttool[base]
else:
    return

tree_list = []
if base_obj is not None:
   tree_list = base_obj.getList(start_depth=rel_level, stop_depth=rel_level)

context_url = ''
context_obj = context.REQUEST.get('context_obj', None)
if context_obj is not None:
    here_rurl =  '/' + utool.getRelativeUrl(context_obj) 
    path_list = here_rurl.split('/')
else:
    return

portal_url = utool(relative=0)
base_create_path = ''
base_create_obj = None
create_url = ''
parent_url = ''

if rel_level > 0:
    parent_treelist = base_obj.getList(start_depth=rel_level-1, stop_depth=rel_level-1)

    for item in parent_treelist:
        rpath = '/' + item['rpath']
        if (here_rurl + '/').startswith(rpath + '/'):
            parent_url = rpath
            base_create_path = utool.getPortalPath() + parent_url 
            break

if rel_level == 1:
    base_create_url = portal_url + '/' + base 
    base_create_obj = base_obj

if base_create_obj is None:
    try:
        base_create_obj = context.restrictedTraverse(base_create_path)
        base_create_url = portal_url + parent_url
    except:
        pass

if rel_level > 0 and base_create_obj is not None and \
        mtool.checkPermission('Add portal content', base_create_obj):
    create_url = base_create_url + '/folder_factories'

menuentries = []

if rel_level > 1 and \
   (rel_level > len(path_list)-1  or \
   not here_rurl.startswith(base_path)):
    create_url = ''

for t in tree_list:
    menuentry = {}
    rpath = '/' + t['rpath']

    if t.get('hidden_folder', None):
        continue
    
    if not rpath.startswith(base_path):
        continue

    if level > 1 and rel_level > 0 and not rpath.startswith(parent_url):
        continue

    if level > 1 and rel_level > 1 and \
       (rel_level > len(path_list)-1  or \
       not here_rurl.startswith(base_path)):
        continue

    menuentry['id'] = t['id']
    menuentry['url'] = portal_url +  rpath
    menuentry['title'] = t['title'] or t['id']
    menuentry['selected'] =  (here_rurl + '/').startswith(rpath + '/')

    # XXX to be changed when the show_docs option is taken into account:
    menuentry['folderish'] = 1
    menuentry['icon'] = 'folder_icon.gif'

    menuentries.append(menuentry)


dict = { 'menuentries' : menuentries, 'create_url' : create_url }

return dict
