##parameters=styleprop=None, edit_mode=None, theme=None

tmtool = context.portal_themes 
mystyle = getattr(context, styleprop, None)

if mystyle is None:
   return

REQUEST = context.REQUEST
url = None

type = None
for obj in context.propertyMap():
   if obj['id'] == styleprop:
        type = obj.get('meta_type')

if type is None:
   return 

for s in tmtool.listStyles(type, context)['object']:
   if getattr(s, 'title') == mystyle:
       url = s.absolute_url() + '/edit_form?edit_mode=' + edit_mode + '&style=' + type + '&theme=' + theme 

if REQUEST is not None and url is not None:
   REQUEST.RESPONSE.redirect(url)
