##parameters=REQUEST=None, theme=None, **kw

tmtool = context.portal_themes
themes_folder = tmtool.getThemeContainer(parent=1)
themes = tmtool.getGlobalThemes()   
mcat = context.cpsskins_getlocalizer()

if REQUEST is not None:
    kw.update(REQUEST.form)

default_theme_list =  kw.get('default_theme', [])
if default_theme_list is not None:
    default_theme = default_theme_list[0]
    tmtool.setDefaultTheme(default_theme)

current_theme = kw['theme']
del kw['theme']

theme_renderers = kw['theme_renderers']
themes_to_delete = kw.get('delete_themes', [])

for i in range(len(themes)):
     params = {}
     theme = themes[i]
     params['theme_renderer'] = theme_renderers[i]

     theme.edit(**params)

for theme_id in themes_to_delete:
    if theme_id == default_theme:
        continue
    tmtool.delObject(themes_folder[theme_id])


theme_container = tmtool.getEffectiveThemeContainer(theme=default_theme)


if REQUEST is not None:
     url = theme_container.absolute_url() + '/cpsskins_themes_manager'  
     url = url + '?portal_status_message=' + mcat('_Themes updated_')
     if default_theme:
        url = url + '&theme=' + default_theme 
     REQUEST.RESPONSE.redirect(url)
