##parameters=level=None, base=None, show_docs=None, base_path=None

if level is None:
   return

if base is None:
   return

if show_docs is None:
   show_docs = 0
else:
   try:
      show_docs=int(show_docs)
   except:
      show_docs = 0

try:
   level = int(level)
except:
   return

REQUEST = context.REQUEST

utool = context.portal_url
mtool = context.portal_membership
portal_url = utool(relative=0)
current_folder = REQUEST.get('context_obj', None)
current_url = '/' + utool.getRelativeUrl(current_folder)

obj_info = []

if base == '':
   base_obj = utool
else:
   base_obj = getattr(utool, base, None)

if base_obj is None:
   return

create_url = ''

dict = {}

for obj in base_obj.contentValues():
       if not show_docs and obj.getTypeInfo().getId() not in ['Folder', 'Portal Folder', 'Plone Folder' ]:
           continue
       info = {}
       rel_path = utool.getRelativeContentPath(obj)
       obj_depth = len(rel_path) -1
       if obj_depth == level:
           title  = rel_path[obj_depth-1]
           if title not in ['themes']:
              id = obj.getId()
              try: 
                 info['title'] = obj.title_or_id()
              except:
                 info['title'] = id
              rurl =  '/' + '/'.join(rel_path)
              url =  portal_url + rurl
              info['url'] = url
              if rurl == current_url:
                 info['selected'] = 1
              else:
                 info['selected'] = 0
                
              info['id'] = id
              info['icon'] = obj.getIcon()
 
              # XXX to be changed when the 'show_docs' option is taken into account
              info['folderish'] = 1
              obj_info.append(info) 

dict['menuentries'] = obj_info
dict['create_url'] = create_url

return dict
