import os
from App.Extensions import getPath
from re import match
from ExtensionClass import Base
import zLOG


def logf(summary,message='',severity=0):
  summary = '['+ str(summary) +']'
  if message:
    message = str(message)+'\n'
  zLOG.LOG('CPSSkinsCollapsibleMenus: ',severity,summary, message)

def install(self):
    logf("START: CPSSkinsCollapsibleMenus")
    log = []
    pr = log.append
    def prok(pr=pr):
        pr(" Already correctly installed")



    pr("<html><head><title>CPSSkins Collapsible Menus</title></head><body><pre>")

    pr("Starting CPSSkinsCollapsibleMenus")

    pr("")


    portal = self.portal_url.getPortalObject()

    def portalhas(id, portal=portal):
        return id in portal.objectIds()

    # Portal types
    pr(" Verifying portal types")
    ptypes = {
	'Collapsible Menu Templet' : { 'tin': 'CPSSkinsCollapsibleMenus: Collapsible Menu Templet',
	              'containers': () },
	'Collapsible Menu Style' : { 'tin': 'CPSSkinsCollapsibleMenus: Collapsible Menu Style',
	              'containers': () },
	}
    
    ttool = portal.portal_types
    
    
    
    for ptype in ptypes.keys():
	dic = ptypes[ptype]
	pr("  Type '%s'" % ptype)
	if ptype in ttool.objectIds():
	     ttool.manage_delObjects([ptype])
	     pr("   Deleted")
	if ptype not in ttool.objectIds():
	    tin = dic['tin']
	    amt = 'Factory-based Type Information'
	    ttool.manage_addTypeInformation(add_meta_type=amt, id=ptype,
	                                    typeinfo_name=tin)
	    pr("   Installed")
	    if tin.find(ptype) < 0:
		# should change title of fti to '_'+ptype+'_'
		ttool[ptype].manage_changeProperties(None, title='_'+ptype+'_')
		pr("   with a new title property")
	else:
	 pr("   Ok")
	    



    # skins
    skins = ('CPSSkinsCollapsibleMenus', )
    paths = {
        'CPSSkinsCollapsibleMenus': 'Products/CPSSkinsCollapsibleMenus/skins',
    }

    for skin in skins:
        path = paths[skin]
        path = path.replace('/', os.sep)
        pr(" FS Directory View '%s'" % skin)
        if skin in portal.portal_skins.objectIds():
            dv = portal.portal_skins[skin]
            oldpath = dv.getDirPath()
            if oldpath == path:
                prok()
            else:
                pr("  Correctly installed, correcting path")
                dv.manage_properties(dirpath=path)
        else:
            portal.portal_skins.manage_addProduct['CMFCore'].manage_addDirectoryView(filepath=path, id=skin)
            pr("  Creating skin")
    allskins = portal.portal_skins.getSkinPaths()
    for skin_name, skin_path in allskins:
        path = [x.strip() for x in skin_path.split(',')]
        path = [x for x in path if x not in skins] # strip all
        if path and path[0] == 'custom':
            path = path[:1] + list(skins) + path[1:]
        else:
            path = list(skins) + path
        npath = ', '.join(path)
        portal.portal_skins.addSkinSelection(skin_name, npath)
        pr(" Fixup of skin %s" % skin_name)

    # importing .po files
    mcat = None
    if portalhas('portal_messages'):
        mcat = portal.portal_messages

    if portalhas('Localizer'):
        mcat = portal['Localizer']['cpsskins']

    if mcat is not None:
        pr(" Checking available languages")
        podir = os.path.join('Products', 'CPSSkinsCollapsibleMenus/i18n')
        popath = getPath(podir, 'CPSSkinsCollapsibleMenus')
        if popath is None:
            pr(" !!! Unable to find .po dir")
        else:
            pr("  Checking installable languages")
            langs = []
            avail_langs = mcat.get_languages()
            pr("    Available languages: %s" % str(avail_langs))
            for file in os.listdir(popath):
                if file.endswith('.po'):
                    m = match('^.*([a-z][a-z])\.po$', file)
                    if m is None:
                        pr( '    Skipping bad file %s' % file)
                        continue
                    lang = m.group(1)
                    if lang in avail_langs:
                        lang_po_path = os.path.join(popath, file)
                        lang_file = open(lang_po_path)
                        pr("    Importing %s into '%s' locale" % (file, lang))
                        mcat.manage_import(lang, lang_file)
                    else:
                        pr( '    Skipping not installed locale for file %s' % file)

    
    pr("End of specific CPSSkinsCollapsibleMenus update")

    pr("</pre></body></html>")
    logf("END:  CPSSkinsCollapsibleMenus")
    return '\n'.join(log)

